/* *** Parser-mania. (c) 1994 Antonio J. Antn. Tlf 96-5881219 *** */

enum parser_tipus { fnc, op, cte };

#define FALSE           (0)
#define TRUE            (!FALSE)

#define IsFunction(x)   (IsType((x), fnc))
#define IsConstant(x)   (IsType((x), cte))
#define IsOperator(x)   (IsType((x), op))
#define IsError()       (errortext[0] != 0)

#define MAX_VARS        100
#define MAX_TOKEN       32
#define MAX_STRING      255
#define MAX_DATA        128

typedef int bool;

typedef struct
{
  int tipus;
  int llargada;
  union
   {
     char operador[3];
     char *string;
     double numero;
     char ident[MAX_TOKEN];
     int codi_paraula;
   } dada;
} item;

typedef struct
{
  int  tipus_node;
  item element;
  void *esquerra;
  void *dreta;
} node;

typedef struct
{
  char ident[MAX_TOKEN];
  item valor;
} variable;

typedef struct
{
  char *ident;
  int  que_es;
  int  parametres;
} reservat;

typedef item     *pitem;
typedef node     *pnode;
typedef variable *pvariable;
typedef reservat *preservat;

/* *** funcions del parser *** */

int    clearerror(void);
char  *GetErrorText(void);
int    initmygetc(char *);
int    IsReservedWord(char *);
bool   IsType(int, int);
pnode  expr(void);
double eval(pnode);
void   lliberar_memoria(pnode);
bool   VariablesDefined(void);
double GetVariable(char *);
double SetVariable(char *, double);
bool   ReleaseVariable(char *);
double Evaluar(char *);

/* **** variables globals del parser **** */

extern unsigned _stklen;       		 /* NOU TAMANY DE LA PILA */
extern pvariable variables[];
extern int       ultima_var;
extern double    parser_result;
extern int       mygetc_pos;
extern char      errortext[];
